#include <bits/stdc++.h>
using namespace std;
int main(int argc, char** argv) {
	long long n, k, t;
	cin>>n>>k;
	deque <long long> a;
	for(int i=0; i<n; i++){
	cin>>t;	
	a.push_back(t);}
	while(k>1){
	if(a.front()-a.back() > a.back() - a.front()){
		a.front() -= a.back();
		a.pop_back();
		t = a.front();}	
	else {
		a.back() -= a.front();
		a.pop_front();
		t = a.back();}	
	k--;}
	cout<< t;
	return 0;}